diff --git a/src/modules/Extensions/OpenSubtitles.cpp b/src/modules/Extensions/OpenSubtitles.cpp
index 06c6050b..eae623ff 100644
--- a/src/modules/Extensions/OpenSubtitles.cpp
+++ b/src/modules/Extensions/OpenSubtitles.cpp
@@ -25,12 +25,14 @@
 #include <QDesktopServices>
 #include <QXmlStreamReader>
 #include <QStringListModel>
-#include <QJsonDocument>
+#include <QJsonDocument.h>
+#include <QJsonObject.h>
 #include <QGridLayout>
+#include <QUrl>
 #include <QTreeWidget>
 #include <QHeaderView>
 #include <QScrollBar>
-#include <QJsonArray>
+#include <QJsonArray.h>
 #include <QCompleter>
 #include <QComboBox>
 #include <QAction>
@@ -65,15 +67,15 @@ enum
 
 static inline QString getBaseUrl()
 {
-    return QStringLiteral("https://www.opensubtitles.org");
+    return QString("https://www.opensubtitles.org");
 }
 static inline QString getSuggestUrl(const QString &text, const QString &lang)
 {
-    return getBaseUrl() + QStringLiteral("/libs/suggest.php?format=json3&MovieName=%1&SubLanguageID=%2").arg(text.toUtf8().toPercentEncoding(), lang);
+    return getBaseUrl() + QString("/libs/suggest.php?format=json3&MovieName=%1&SubLanguageID=%2").arg(text.toUtf8().toPercentEncoding(), lang);
 }
 static inline QString getSearchUrl(const QString &text, const QString &lang)
 {
-    return getBaseUrl() + QStringLiteral("/search2/moviename-%1/sublanguageid-%2/xml").arg(text.toUtf8().toPercentEncoding(), lang);
+    return getBaseUrl() + QString("/search2/moviename-%1/sublanguageid-%2/xml").arg(text.toUtf8().toPercentEncoding(), lang);
 }
 
 struct OpenSubtitles::Subtitle
@@ -115,29 +117,17 @@ OpenSubtitles::OpenSubtitles(Module &module, const QIcon &icon)
 
     m_completerTimer->setSingleShot(true);
     m_completerTimer->setInterval(250);
-    connect(m_completerTimer, &QTimer::timeout, this, [this] {
-        complete();
-    });
+    connect(m_completerTimer, SIGNAL(timeout()), this, SLOT(onCompleterTimeout()));
 
     m_searchEdit->setPlaceholderText(tr("Type the movie name and press enter"));
     m_searchEdit->setCompleter(completer);
-    connect(m_searchEdit, &LineEdit::clearButtonClicked, this, [this] {
-        clearCompleter();
-        search();
-    });
-    connect(m_searchEdit, &QLineEdit::textEdited, this, [this](const QString &text) {
-        Q_UNUSED(text);
-        m_dontComplete = false;
-        m_completerTimer->start();
-    });
-    connect(m_searchEdit, &QLineEdit::returnPressed, this, [this] {
-        m_dontComplete = true;
-        search();
-    });
+    connect(m_searchEdit, SIGNAL(clearButtonClicked()), this, SLOT(onSearchEditClearButtonClicked()));
+    connect(m_searchEdit, SIGNAL(textEdited(QString)), this, SLOT(onSearchEditTextEdited(QString)));
+    connect(m_searchEdit, SIGNAL(returnPressed()), this, SLOT(onSearchEditReturnPressed()));
 
     m_languages->setToolTip(tr("Choose subtitles language"));
     m_languages->setSizeAdjustPolicy(QComboBox::AdjustToContents);
-    const auto lang = sets().getString(QStringLiteral("Language"), QStringLiteral("eng"));
+    const auto lang = sets().getString(QString("Language"), QString("eng"));
 #if QT_VERSION < QT_VERSION_CHECK(6, 0, 0)
     const auto languagesMap = QMPlay2Core.getLanguagesMap();
     for (auto it = languagesMap.constBegin(), itEnd = languagesMap.constEnd(); it != itEnd; ++it)
@@ -162,78 +152,19 @@ OpenSubtitles::OpenSubtitles(Module &module, const QIcon &icon)
             m_languages->setCurrentIndex(idx);
         }
     }
-#if QT_VERSION < QT_VERSION_CHECK(6, 0, 0)
-    connect(m_languages, qOverload<int>(&QComboBox::currentIndexChanged), this, [this](int idx) {
-#else
-    connect(m_languages, &QComboBox::currentIndexChanged, this, [this](int idx) {
-#endif
-        Q_UNUSED(idx)
-        sets().set(QStringLiteral("Language"), getLanguage());
-        search();
-    });
+    connect(m_languages, SIGNAL(currentIndexChanged(int)), this, SLOT(onLanguageChanged(int)));
 
     m_results->setContextMenuPolicy(Qt::CustomContextMenu);
     m_results->setIconSize(QSize(47, 47));
     m_results->setSortingEnabled(true);
     m_results->setColumnCount(3);
     m_results->setAnimated(true);
-    connect(m_results, &QTreeWidget::customContextMenuRequested, this, [this](const QPoint &p) {
-        Q_UNUSED(p);
-        if (const auto twi = m_results->currentItem())
-        {
-            const auto url = twi->data(0, DownloadUrlRole).toString();
-            if (!url.isEmpty())
-            {
-                QMenu menu(m_results);
-                menu.addAction(tr("Download in default web browser"), this, [url] {
-                    QDesktopServices::openUrl(url);
-                });
-                menu.exec(QCursor::pos());
-            }
-        }
-    });
-    connect(m_results, &QTreeWidget::itemExpanded, this, [this](QTreeWidgetItem *twi) {
-        if (Q_UNLIKELY(!twi))
-            return;
-
-        if (twi->childCount() == 1)
-        {
-            const auto subItem = twi->child(0);
-            const auto url = twi->data(0, SubItemUrlRole).toString();
-            if (!url.isEmpty())
-            {
-                subItem->setText(0, tr("Loading..."));
-                twi->setData(0, SubItemUrlRole, QVariant());
-                twi->setData(0, SubItemUrlRoleBak, url);
-                loadSubItem(url, m_results->indexFromItem(twi), false);
-            }
-        }
-    });
-    connect(m_results, &QTreeWidget::itemDoubleClicked, this, [](QTreeWidgetItem *twi, int column) {
-        Q_UNUSED(column);
-
-        if (Q_UNLIKELY(!twi))
-            return;
+    connect(m_results, SIGNAL(customContextMenuRequested(QPoint)), this, SLOT(onResultsCustomContextMenuRequested(QPoint)));
+    connect(m_results, SIGNAL(itemExpanded(QTreeWidgetItem*)), this, SLOT(onResultsItemExpanded(QTreeWidgetItem*)));
+    connect(m_results, SIGNAL(itemDoubleClicked(QTreeWidgetItem*,int)), this, SLOT(onResultsItemDoubleClicked(QTreeWidgetItem*,int)));
 
-        if (!twi->parent() || Q_UNLIKELY(twi->childCount() != 0))
-            return;
-
-        const auto url = twi->data(0, DownloadUrlRole).toString();
-        if (url.isEmpty())
-            return;
-
-        QDesktopServices::openUrl(url);
-    });
-
-    connect(m_results->verticalScrollBar(), &QScrollBar::rangeChanged, this, [this](int min, int max) {
-        Q_UNUSED(min)
-        Q_UNUSED(max)
-        scanForToUrl();
-    });
-    connect(m_results->verticalScrollBar(), &QScrollBar::valueChanged, this, [this](int value) {
-        Q_UNUSED(value)
-        scanForToUrl();
-    });
+    connect(m_results->verticalScrollBar(), SIGNAL(rangeChanged(int,int)), this, SLOT(onScrollBarRangeChanged(int,int)));
+    connect(m_results->verticalScrollBar(), SIGNAL(valueChanged(int)), this, SLOT(onScrollBarValueChanged(int)));
 
     const auto headerItem = m_results->headerItem();
     headerItem->setText(0, tr("Movie name"));
@@ -242,9 +173,15 @@ OpenSubtitles::OpenSubtitles(Module &module, const QIcon &icon)
 
     const auto header = m_results->header();
     header->setStretchLastSection(false);
+#if QT_VERSION >= QT_VERSION_CHECK(5, 0, 0)
     header->setSectionResizeMode(0, QHeaderView::Stretch);
     header->setSectionResizeMode(1, QHeaderView::ResizeToContents);
     header->setSectionResizeMode(2, QHeaderView::ResizeToContents);
+#else
+    header->setResizeMode(0, QHeaderView::Stretch);
+    header->setResizeMode(1, QHeaderView::ResizeToContents);
+    header->setResizeMode(2, QHeaderView::ResizeToContents);
+#endif
     header->setSortIndicator(-1, Qt::AscendingOrder);
 
     auto layout = new QGridLayout(this);
@@ -266,13 +203,8 @@ QVector<QAction *> OpenSubtitles::getActions(const QString &name, double, const
     if (name != url)
     {
         auto act = new QAction(tr("Search on OpenSubtitles"), nullptr);
-        act->connect(act, &QAction::triggered, this, [this, name](bool checked) {
-            Q_UNUSED(checked)
-            clearCompleter();
-            m_searchEdit->setText(name);
-            search();
-            m_dw->raise();
-        });
+        act->setData(name); // Store search term for slot
+        act->connect(act, SIGNAL(triggered(bool)), this, SLOT(onLanguageActionTriggered(bool)));
         act->setIcon(m_icon);
         return {act};
     }
@@ -287,7 +219,8 @@ void OpenSubtitles::parseCompleterJson(const QByteArray &data)
     titles.reserve(array.size());
     for (auto &&element : array)
     {
-        const auto title = element[QStringLiteral("name")].toString();
+        const QJsonObject elementObj = element.toObject();
+        const auto title = elementObj[QString("name")].toString();
         if (!title.isEmpty())
         {
             titles.push_back(title);
@@ -328,8 +261,8 @@ void OpenSubtitles::parseXml(const QByteArray &data, QTreeWidgetItem *parentTwi)
         const auto name = xml.name();
         const auto attrs = xml.attributes();
 
-        const bool isResultsFound = (name.compare(QStringLiteral("results_found"), Qt::CaseInsensitive) == 0);
-        const bool isSubtitle = (name.compare(QStringLiteral("subtitle"), Qt::CaseInsensitive) == 0);
+        const bool isResultsFound = (name.compare(QString("results_found"), Qt::CaseInsensitive) == 0);
+        const bool isSubtitle = (name.compare(QString("subtitle"), Qt::CaseInsensitive) == 0);
 
         if (tokenType != QXmlStreamReader::StartElement)
         {
@@ -350,11 +283,11 @@ void OpenSubtitles::parseXml(const QByteArray &data, QTreeWidgetItem *parentTwi)
 
         if (inResultsFound)
         {
-            if (name == QStringLiteral("to"))
+            if (name == QString("to"))
             {
                 if (toUrl.isEmpty())
                 {
-                    toUrl = attrs.value(QStringLiteral("Linker")).toString();
+                    toUrl = attrs.value(QString("Linker")).toString();
                     if (!toUrl.isEmpty())
                         toUrl.prepend(getBaseUrl());
                 }
@@ -363,90 +296,90 @@ void OpenSubtitles::parseXml(const QByteArray &data, QTreeWidgetItem *parentTwi)
         else if (inSubtitle)
         {
             Q_ASSERT(subtitle);
-            if (name == QStringLiteral("IDSubtitle"))
+            if (name == QString("IDSubtitle"))
             {
                 if (subtitle->downloadUrl.isEmpty())
-                    subtitle->downloadUrl = attrs.value(QStringLiteral("LinkDownload")).toString();
+                    subtitle->downloadUrl = attrs.value(QString("LinkDownload")).toString();
             }
-            else if (name == QStringLiteral("MovieName"))
+            else if (name == QString("MovieName"))
             {
                 if (subtitle->name.isEmpty())
                     subtitle->name = xml.readElementText();
             }
-            else if (name == QStringLiteral("EpisodeName"))
+            else if (name == QString("EpisodeName"))
             {
                 if (subtitle->episodeName.isEmpty())
                     subtitle->episodeName = xml.readElementText();
                 if (subtitle->episodeUrl.isEmpty())
-                    subtitle->episodeUrl = getBaseUrl() + attrs.value(QStringLiteral("Link")).toString() + "/xml";
+                    subtitle->episodeUrl = getBaseUrl() + attrs.value(QString("Link")).toString() + "/xml";
             }
-            else if (name == QStringLiteral("MovieThumb"))
+            else if (name == QString("MovieThumb"))
             {
                 if (subtitle->thumbUrl.isEmpty())
                     subtitle->thumbUrl = xml.readElementText();
             }
-            else if (name == QStringLiteral("MovieReleaseName"))
+            else if (name == QString("MovieReleaseName"))
             {
                 if (subtitle->releaseName.isEmpty())
                     subtitle->releaseName = xml.readElementText();
                 if (subtitle->downloadUrl.isEmpty())
-                    subtitle->downloadUrl = getBaseUrl() + attrs.value(QStringLiteral("Link")).toString();
+                    subtitle->downloadUrl = getBaseUrl() + attrs.value(QString("Link")).toString();
             }
-            else if (name == QStringLiteral("SubFormat"))
+            else if (name == QString("SubFormat"))
             {
                 if (subtitle->format.isEmpty())
                     subtitle->format = xml.readElementText();
             }
-            else if (name == QStringLiteral("SubDownloadsCnt"))
+            else if (name == QString("SubDownloadsCnt"))
             {
                 if (subtitle->downloadsCount.isEmpty())
                    subtitle->downloadsCount = xml.readElementText();
             }
-            else if (name == QStringLiteral("SubDate"))
+            else if (name == QString("SubDate"))
             {
                 if (subtitle->subDate.isEmpty())
                     subtitle->subDate = xml.readElementText();
             }
-            else if (name == QStringLiteral("MovieYear"))
+            else if (name == QString("MovieYear"))
             {
                 if (subtitle->movieYear.isEmpty())
                     subtitle->movieYear = xml.readElementText();
             }
-            else if (name == QStringLiteral("MovieID"))
+            else if (name == QString("MovieID"))
             {
                 if (subtitle->movieUrl.isEmpty())
-                    subtitle->movieUrl = getBaseUrl() + attrs.value(QStringLiteral("Link")).toString();
+                    subtitle->movieUrl = getBaseUrl() + attrs.value(QString("Link")).toString();
             }
-            else if (name == QStringLiteral("SeriesSeason"))
+            else if (name == QString("SeriesSeason"))
             {
                 if (subtitle->seriesSeason.isEmpty())
                     subtitle->seriesSeason = xml.readElementText();
             }
-            else if (name == QStringLiteral("SeriesSubtitles"))
+            else if (name == QString("SeriesSubtitles"))
             {
                 if (subtitle->seriesSubtitles.isEmpty())
                     subtitle->seriesSubtitles = xml.readElementText();
             }
 #if 0
-            else if (name == QStringLiteral("SeriesDownloadsCnt"))
+            else if (name == QString("SeriesDownloadsCnt"))
             {
                 if (subtitle->downloadUrl.isEmpty())
-                    subtitle->downloadUrl = attrs.value(QStringLiteral("LinkDownload")).toString();
+                    subtitle->downloadUrl = attrs.value(QString("LinkDownload")).toString();
                 if (subtitle->downloadsCount.isEmpty())
                     subtitle->downloadsCount = xml.readElementText();
             }
-            else if (name == QStringLiteral("Newest"))
+            else if (name == QString("Newest"))
             {
                 if (subtitle->subDate.isEmpty())
                     subtitle->subDate = xml.readElementText();
             }
 #endif
-            else if (name == QStringLiteral("Subtitle"))
+            else if (name == QString("Subtitle"))
             {
                 if (subtitle->downloadUrl.isEmpty())
-                    subtitle->downloadUrl = attrs.value(QStringLiteral("LinkDownload")).toString();
+                    subtitle->downloadUrl = attrs.value(QString("LinkDownload")).toString();
                 if (subtitle->subDate.isEmpty())
-                    subtitle->subDate = attrs.value(QStringLiteral("SubAddDate")).toString();
+                    subtitle->subDate = attrs.value(QString("SubAddDate")).toString();
             }
         }
         else if (isResultsFound)
@@ -469,7 +402,7 @@ void OpenSubtitles::parseXml(const QByteArray &data, QTreeWidgetItem *parentTwi)
             return new QTreeWidgetItem(parentTwi);
         return new QTreeWidgetItem(m_results);
     };
-    for (auto &&subtitle : std::as_const(subtitles))
+    for (auto &&subtitle : subtitles)
     {
         if (!subtitle.episodeUrl.isEmpty())
         {
@@ -482,7 +415,7 @@ void OpenSubtitles::parseXml(const QByteArray &data, QTreeWidgetItem *parentTwi)
             if (subtitle.seriesSeason.toInt() > 0)
                 twi->setText(0, tr("%1 (Season %2)").arg(subtitle.episodeName, subtitle.seriesSeason));
             else
-                twi->setText(0, QStringLiteral("%1").arg(subtitle.episodeName));
+                twi->setText(0, QString("%1").arg(subtitle.episodeName));
 
             new QTreeWidgetItem(twi);
             twi->setData(0, SubItemUrlRole, subtitle.episodeUrl);
@@ -501,9 +434,9 @@ void OpenSubtitles::parseXml(const QByteArray &data, QTreeWidgetItem *parentTwi)
 
             auto twi = createTwi();
             if (!subtitle.movieYear.isEmpty())
-                twi->setText(0, QStringLiteral("%1 (%2)").arg(name, subtitle.movieYear));
+                twi->setText(0, QString("%1 (%2)").arg(name, subtitle.movieYear));
             else
-                twi->setText(0, QStringLiteral("%1").arg(name));
+                twi->setText(0, QString("%1").arg(name));
             twi->setText(1, subtitle.subDate);
             twi->setData(2, Qt::UserRole + 0, subtitle.downloadsCount);
             twi->setData(2, Qt::UserRole + 1, subtitle.format);
@@ -530,18 +463,17 @@ void OpenSubtitles::parseXml(const QByteArray &data, QTreeWidgetItem *parentTwi)
             auto twi = createTwi();
             twi->setText(0, subtitle.name + " (" + subtitle.movieYear + ")");
 
-            if (subtitle.thumbUrl.startsWith(QStringLiteral("http")))
+            if (subtitle.thumbUrl.startsWith(QString("http")))
             {
                 auto reply = m_net->start(subtitle.thumbUrl);
                 m_loadThumbnailReplies.push_back(reply);
-                connect(reply, &NetworkReply::finished, this, [this, reply, twi] {
-                    if (!reply->hasError() && m_results->indexOfTopLevelItem(twi) > -1)
-                    {
-                        twi->setIcon(0, QIcon(QPixmap::fromImage(QImage::fromData(reply->readAll()))));
-                    }
-                    m_loadThumbnailReplies.removeOne(reply);
-                    reply->deleteLater();
-                });
+
+                ReplyData data;
+                data.reply = reply;
+                data.twi = twi;
+                m_replyDataMap[reply] = data;
+
+                connect(reply, SIGNAL(finished()), this, SLOT(onThumbnailReplyFinished()));
             }
 
             new QTreeWidgetItem(twi);
@@ -575,7 +507,7 @@ void OpenSubtitles::parseXml(const QByteArray &data, QTreeWidgetItem *parentTwi)
             downloadCountFieldWidth = qMax(downloadCountFieldWidth , twi->data(2, Qt::UserRole + 0).toString().size());
         });
         iterateItems([&downloadCountFieldWidth](QTreeWidgetItem *twi) {
-            twi->setText(2, QStringLiteral("%1x (%2)").arg(twi->data(2, Qt::UserRole + 0).toString(), downloadCountFieldWidth).arg(twi->data(2, Qt::UserRole + 1).toString()));
+            twi->setText(2, QString("%1x (%2)").arg(twi->data(2, Qt::UserRole + 0).toString(), downloadCountFieldWidth).arg(twi->data(2, Qt::UserRole + 1).toString()));
         });
     }
 
@@ -593,19 +525,17 @@ void OpenSubtitles::complete()
     if (m_completerReply)
     {
         m_completerReply->abort();
+#if QT_VERSION >= QT_VERSION_CHECK(5, 0, 0)
         m_completerReply.clear();
+#else
+        m_completerReply = nullptr;
+#endif
     }
 
     if (const auto text = m_searchEdit->text().simplified(); !text.isEmpty())
     {
         m_completerReply = m_net->start(getSuggestUrl(text, getLanguage()));
-        connect(m_completerReply, &NetworkReply::finished, this, [this, completerReply = m_completerReply] {
-            if (!completerReply->hasError())
-            {
-                parseCompleterJson(completerReply->readAll());
-            }
-            completerReply->deleteLater();
-        });
+        connect(m_completerReply, SIGNAL(finished()), this, SLOT(onCompleterReplyFinished()));
     }
     else
     {
@@ -648,16 +578,20 @@ void OpenSubtitles::search()
     if (m_searchReply)
     {
         m_searchReply->abort();
+#if QT_VERSION >= QT_VERSION_CHECK(5, 0, 0)
         m_searchReply.clear();
+#else
+        m_searchReply = nullptr;
+#endif
     }
 
-    for (auto &&reply : std::as_const(m_loadSubItemReplies))
+    for (auto &&reply : m_loadSubItemReplies)
     {
         reply->abort();
     }
     m_loadSubItemReplies.clear();
 
-    for (auto &&reply : std::as_const(m_loadThumbnailReplies))
+    for (auto &&reply : m_loadThumbnailReplies)
     {
         reply->abort();
     }
@@ -668,22 +602,7 @@ void OpenSubtitles::search()
         m_searchReply = m_net->start(getSearchUrl(text, getLanguage()));
         setBusyCursor(true);
         m_results->setEnabled(false);
-        connect(m_searchReply, &NetworkReply::finished, this, [this, searchReply = m_searchReply] {
-            m_results->clear();
-            if (!searchReply->hasError())
-            {
-                parseXml(searchReply->readAll());
-                m_results->scrollToTop();
-            }
-            else
-            {
-                auto twi = new QTreeWidgetItem(m_results);
-                twi->setText(0, tr("Error"));
-            }
-            setBusyCursor(false);
-            m_results->setEnabled(true);
-            searchReply->deleteLater();
-        });
+        connect(m_searchReply, SIGNAL(finished()), this, SLOT(onSearchReplyFinished()));
     }
     else
     {
@@ -698,19 +617,16 @@ void OpenSubtitles::searchNext()
     if (m_searchReply)
     {
         m_searchReply->abort();
+#if QT_VERSION >= QT_VERSION_CHECK(5, 0, 0)
         m_searchReply.clear();
+#else
+        m_searchReply = nullptr;
+#endif
     }
 
     m_searchReply = m_net->start(m_toUrl);
     setBusyCursor(true);
-    connect(m_searchReply, &NetworkReply::finished, this, [this, searchReply = m_searchReply] {
-        if (!searchReply->hasError())
-        {
-            parseXml(searchReply->readAll());
-        }
-        setBusyCursor(false);
-        searchReply->deleteLater();
-    });
+    connect(m_searchReply, SIGNAL(finished()), this, SLOT(onSearchNextReplyFinished()));
 
     m_toUrl.clear();
 }
@@ -719,11 +635,233 @@ void OpenSubtitles::loadSubItem(const QString &url, const QPersistentModelIndex
     auto reply = m_net->start(url);
     setBusyCursor(true);
     m_loadSubItemReplies.push_back(reply);
-    connect(reply, &NetworkReply::finished, this, [this, reply, index, next] {
-        const auto twi = m_results->itemFromIndex(index);
-        if (Q_LIKELY(twi) && (next || Q_LIKELY(twi->childCount() == 1)))
+
+    ReplyData data;
+    data.reply = reply;
+    data.index = index;
+    data.next = next;
+    m_replyDataMap[reply] = data;
+
+    connect(reply, SIGNAL(finished()), this, SLOT(onLoadSubItemReplyFinished()));
+}
+
+void OpenSubtitles::setBusyCursor(bool set)
+{
+    if (set)
+    {
+        if (++m_busyCursor == 1)
+        {
+            setCursor(Qt::BusyCursor);
+        }
+    }
+    else if (m_busyCursor > 0 && --m_busyCursor == 0)
+    {
+        setCursor(QCursor());
+    }
+}
+
+// Qt4 slot implementations
+
+void OpenSubtitles::onCompleterTimeout()
+{
+    complete();
+}
+
+void OpenSubtitles::onSearchEditClearButtonClicked()
+{
+    clearCompleter();
+    search();
+}
+
+void OpenSubtitles::onSearchEditTextEdited(const QString &text)
+{
+    Q_UNUSED(text);
+    m_dontComplete = false;
+    m_completerTimer->start();
+}
+
+void OpenSubtitles::onSearchEditReturnPressed()
+{
+    m_dontComplete = true;
+    search();
+}
+
+void OpenSubtitles::onLanguageChanged(int idx)
+{
+    Q_UNUSED(idx)
+    sets().set(QString("Language"), getLanguage());
+    search();
+}
+
+void OpenSubtitles::onResultsCustomContextMenuRequested(const QPoint &p)
+{
+    Q_UNUSED(p);
+    if (const auto twi = m_results->currentItem())
+    {
+        const auto url = twi->data(0, DownloadUrlRole).toString();
+        if (!url.isEmpty())
+        {
+            QDesktopServices::openUrl(QUrl(url));
+        }
+    }
+}
+
+void OpenSubtitles::onResultsItemExpanded(QTreeWidgetItem *twi)
+{
+    if (Q_UNLIKELY(!twi))
+        return;
+
+    if (twi->childCount() == 1)
+    {
+        const auto subItem = twi->child(0);
+        const auto url = twi->data(0, SubItemUrlRole).toString();
+        if (!url.isEmpty())
+        {
+            subItem->setText(0, tr("Loading..."));
+            twi->setData(0, SubItemUrlRole, QVariant());
+            twi->setData(0, SubItemUrlRoleBak, url);
+            loadSubItem(url, m_results->indexFromItem(twi), false);
+        }
+    }
+}
+
+void OpenSubtitles::onResultsItemDoubleClicked(QTreeWidgetItem *twi, int column)
+{
+    Q_UNUSED(column);
+
+    if (Q_UNLIKELY(!twi))
+        return;
+
+    if (!twi->parent() || Q_UNLIKELY(twi->childCount() != 0))
+        return;
+
+    const auto url = twi->data(0, DownloadUrlRole).toString();
+    if (url.isEmpty())
+        return;
+
+    QDesktopServices::openUrl(QUrl(url));
+}
+
+void OpenSubtitles::onScrollBarRangeChanged(int min, int max)
+{
+    Q_UNUSED(min)
+    Q_UNUSED(max)
+    scanForToUrl();
+}
+
+void OpenSubtitles::onScrollBarValueChanged(int value)
+{
+    Q_UNUSED(value)
+    scanForToUrl();
+}
+
+void OpenSubtitles::onLanguageActionTriggered(bool checked)
+{
+    Q_UNUSED(checked)
+    QAction *act = qobject_cast<QAction*>(sender());
+    if (!act)
+        return;
+
+    QString name = act->data().toString();
+    clearCompleter();
+    m_searchEdit->setText(name);
+    search();
+    m_dw->raise();
+}
+
+void OpenSubtitles::onThumbnailReplyFinished()
+{
+    NetworkReply *reply = qobject_cast<NetworkReply*>(sender());
+    if (!reply)
+        return;
+
+    auto it = m_replyDataMap.find(reply);
+    if (it != m_replyDataMap.end())
+    {
+        ReplyData data = it.value();
+        m_replyDataMap.erase(it);
+
+        if (!reply->hasError() && m_results->indexOfTopLevelItem(data.twi) > -1)
+        {
+            data.twi->setIcon(0, QIcon(QPixmap::fromImage(QImage::fromData(reply->readAll()))));
+        }
+#if QT_VERSION >= QT_VERSION_CHECK(5, 0, 0)
+        m_loadThumbnailReplies.removeOne(reply);
+#else
+        // Qt4: QVector doesn't have removeOne, use indexOf + remove
+        int idx = m_loadThumbnailReplies.indexOf(reply);
+        if (idx >= 0)
+            m_loadThumbnailReplies.remove(idx);
+#endif
+        reply->deleteLater();
+    }
+}
+
+void OpenSubtitles::onCompleterReplyFinished()
+{
+    NetworkReply *completerReply = m_completerReply;
+    if (!completerReply)
+        return;
+
+    if (!completerReply->hasError())
+    {
+        parseCompleterJson(completerReply->readAll());
+    }
+    completerReply->deleteLater();
+}
+
+void OpenSubtitles::onSearchReplyFinished()
+{
+    NetworkReply *searchReply = m_searchReply;
+    if (!searchReply)
+        return;
+
+    m_results->clear();
+    if (!searchReply->hasError())
+    {
+        parseXml(searchReply->readAll());
+        m_results->scrollToTop();
+    }
+    else
+    {
+        auto twi = new QTreeWidgetItem(m_results);
+        twi->setText(0, tr("Error"));
+    }
+    setBusyCursor(false);
+    m_results->setEnabled(true);
+    searchReply->deleteLater();
+}
+
+void OpenSubtitles::onSearchNextReplyFinished()
+{
+    NetworkReply *searchReply = m_searchReply;
+    if (!searchReply)
+        return;
+
+    if (!searchReply->hasError())
+    {
+        parseXml(searchReply->readAll());
+    }
+    setBusyCursor(false);
+    searchReply->deleteLater();
+}
+
+void OpenSubtitles::onLoadSubItemReplyFinished()
+{
+    NetworkReply *reply = qobject_cast<NetworkReply*>(sender());
+    if (!reply)
+        return;
+
+    auto it = m_replyDataMap.find(reply);
+    if (it != m_replyDataMap.end())
+    {
+        ReplyData data = it.value();
+        m_replyDataMap.erase(it);
+
+        const auto twi = m_results->itemFromIndex(data.index);
+        if (Q_LIKELY(twi) && (data.next || Q_LIKELY(twi->childCount() == 1)))
         {
-            auto loadingTwi = next
+            auto loadingTwi = data.next
                 ? nullptr
                 : twi->child(0)
             ;
@@ -745,23 +883,15 @@ void OpenSubtitles::loadSubItem(const QString &url, const QPersistentModelIndex
             }
         }
         setBusyCursor(false);
+#if QT_VERSION >= QT_VERSION_CHECK(5, 0, 0)
         m_loadSubItemReplies.removeOne(reply);
+#else
+        // Qt4: QVector doesn't have removeOne, use indexOf + remove
+        int idx = m_loadSubItemReplies.indexOf(reply);
+        if (idx >= 0)
+            m_loadSubItemReplies.remove(idx);
+#endif
         reply->deleteLater();
-    });
-}
-
-void OpenSubtitles::setBusyCursor(bool set)
-{
-    if (set)
-    {
-        if (++m_busyCursor == 1)
-        {
-            setCursor(Qt::BusyCursor);
-        }
-    }
-    else if (m_busyCursor > 0 && --m_busyCursor == 0)
-    {
-        setCursor(QCursor());
     }
 }
 
@@ -772,5 +902,9 @@ inline void OpenSubtitles::clearCompleter()
 
 inline QString OpenSubtitles::getLanguage() const
 {
+#if QT_VERSION >= QT_VERSION_CHECK(5, 0, 0)
     return m_languages->currentData().toString();
+#else
+    return m_languages->itemData(m_languages->currentIndex()).toString();
+#endif
 }
diff --git a/src/modules/Extensions/OpenSubtitles.hpp b/src/modules/Extensions/OpenSubtitles.hpp
index 9186abc9..bdc5c82c 100644
--- a/src/modules/Extensions/OpenSubtitles.hpp
+++ b/src/modules/Extensions/OpenSubtitles.hpp
@@ -21,6 +21,7 @@
 #include <QMPlay2Extensions.hpp>
 
 #include <QPointer>
+#include <QPersistentModelIndex>
 
 class QTreeWidgetItem;
 class NetworkAccess;
@@ -29,14 +30,14 @@ class QComboBox;
 class LineEdit;
 class QTimer;
 
-#if QT_VERSION < QT_VERSION_CHECK(6, 0, 0)
+#if QT_VERSION < 0x060000
 class TreeWidget;
 #else
 class QTreeWidget;
 using TreeWidget = QTreeWidget;
 #endif
 
-class OpenSubtitles final : public QWidget, public QMPlay2Extensions
+class OpenSubtitles : public QWidget, public QMPlay2Extensions
 {
     Q_OBJECT
 
@@ -46,9 +47,9 @@ public:
     OpenSubtitles(Module &module, const QIcon &icon);
     ~OpenSubtitles();
 
-    DockWidget *getDockWidget() override;
+    DockWidget *getDockWidget();
 
-    QVector<QAction *> getActions(const QString &name, double, const QString &url, const QString &, const QString &) override;
+    QVector<QAction *> getActions(const QString &name, double, const QString &url, const QString &, const QString &);
 
 private:
     void parseCompleterJson(const QByteArray &data);
@@ -68,7 +69,41 @@ private:
 
     inline QString getLanguage() const;
 
+private slots:
+    void onCompleterTimeout();
+    void onSearchEditClearButtonClicked();
+    void onSearchEditTextEdited(const QString &text);
+    void onSearchEditReturnPressed();
+    void onLanguageChanged(int idx);
+    void onResultsCustomContextMenuRequested(const QPoint &p);
+    void onResultsItemExpanded(QTreeWidgetItem *twi);
+    void onResultsItemDoubleClicked(QTreeWidgetItem *twi, int column);
+    void onScrollBarRangeChanged(int min, int max);
+    void onScrollBarValueChanged(int value);
+    void onLanguageActionTriggered(bool checked);
+    void onThumbnailReplyFinished();
+    void onCompleterReplyFinished();
+    void onSearchReplyFinished();
+    void onSearchNextReplyFinished();
+    void onLoadSubItemReplyFinished();
+
 private:
+    struct ReplyData {
+        QPointer<NetworkReply> reply;
+        QTreeWidgetItem *twi;
+        QPersistentModelIndex index;
+        bool next;
+
+        ReplyData() : twi(nullptr), next(false) {}
+#if QT_VERSION >= 0x050000
+        ReplyData(const ReplyData &) = default;
+        ReplyData &operator=(const ReplyData &) = default;
+#endif
+    };
+
+    QHash<QAction*, QString> m_languageActions;
+    QHash<QObject*, ReplyData> m_replyDataMap;
+
     const QIcon m_icon;
 
     DockWidget *const m_dw;
